/* Makefile:
 * >>> snip <<<
 * SRCS=pony.c
 * KMOD=pony
 *
 * .include <bsd.kmod.mk>
 * >>> snip <<<
 *
 * Author : rhaamo <markocpc@gmail.com>
 * Licence : http://sam.zoy.org/wtfpl/
 */

#include <sys/param.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/systm.h>  /* uprintf */

int p_int;
int p_int2 = 1;

static int event_handler(struct module *module, int event, void *arg) {
    int e = 0;  /* ERROR, 0 = normal */
    switch (event) {
        case MOD_LOAD:
            /* Messages */
            printf("PONY: FreeBSD Module v0.1 Loaded\n");
            printf("PONY: Starting ponying your system\n");
            printf("  ,  ,.~\"\"\"\"\"~~..                                           ___\n");
            printf("  )\\,)\\`-,       `~._                                     .'   ``._\n");
            printf("  \\  \\ | )           `~._                   .-\"\"\"\"\"-._   /         \n");
            printf(" _/ ('  ( _(\\            `~~,__________..-\"'          `-<           \\\n");
            printf(" )   )   `   )/)   )        \\                            \\           |\n");
            printf("') /)`      \\` \\,-')/\\      (                             \\          |\n");
            printf("(_(\\ /7      |.   /'  )'  _(`                              |         |\n");
            printf("    \\\\      (  `.     ')_/`                                |         /\n");
            printf("     \\       \\   \\                                         |        (\n");
            printf("      \\ )  /\\/   /                                         |         `~._\n");
            printf("       `-._)     |                                        /.            `~,\n");
            printf("                 |                          |           .'  `~.          (`\n");
            printf("                  \\                       _,\\          /       \\        (``\n");
            printf("                   `/      /       __..-i\"   \\         |        \\      (``\n");
            printf("                  .'     _/`-..--\"\"      `.   `.        \\        ) _.~<``\n");
            printf("                .'    _.j     /            `-.  `.       \\      '=< `\n");
            printf("              .'   _.'   \\    |               `.  `.      \\\n");
            printf("             |   .'       ;   ;               .'  .'`.     \\\n");
            printf("             \\_  `.       |   \\             .'  .'   /    .'\n");
            printf("               `.  `-, __ \\   /           .'  .'     |   (\n");
            printf("                 `.  `'` \\|  |           /  .-`     /   .'\n");
            printf("                   `-._.--t  ;          |_.-)      /  .'\n");
            printf("                          ; /           \\  /      / .'\n");
            printf("                         / /             `'     .' /\n");
            printf("                        /,_\\                  .',_(\n");
            printf("                       /___(                 /___( \n");

           break;


        case MOD_UNLOAD:
           /* Messages */
            printf("PONY: Oh noes ! U kill the pony !\n");
            printf("PONY unloaded.\n");

            break;
        default:
            e = EOPNOTSUPP; /* operation not supported */
            break;
    }

    return(e);

}

static moduledata_t pony = {
    "pony",
    event_handler,
    NULL
};

DECLARE_MODULE(pony, pony, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);




